# `color` CSS Property <sup>standard name</sup>

## Summary

The text color of an element.

## Details

* unit: [color](units/color.md)
* default value: depends on the system (in most cases: `#000000`)
* apply to: `<text>`, `<input>`

## Compares with CSS Standard

* The effect not apply to all elements, just `<text>` and `<input>`. In another way, it's not inherited.
* The color unit definition is a subset of CSS Standard. See [more](units/color.md).

## Example

```html
<template>
  <div>
    <text style="color: #ff0000;">I am Red.</text>
  </div>
</template>
```
