# `font-weight` CSS Property <sup>standard name</sup>

## Summary

The weight of the font for an element.

## Details

* values: `normal`, `bold`
* default value: `normal`
* apply to: `<text>`, `<input>`

## Compares with CSS Standard

* Some standard values like `lighter`, `bolder`, number unit are not supported.
* The effect not apply to all elements, just `<text>` and `<input>`. In another way, it's not inherited.

## Example

```html
<template>
  <div>
    <text style="font-weight: bold;">Hello World</text>
  </div>
</template>
```
