# `text-align` CSS Property <sup>standard name</sup>

## Summary

Describes how text content is aligned.

## Details

* values: `left`, `center`, `right`
* default value: `left`
* apply to: `<text>`, `<input>`

## Compares with CSS Standard

* Some standard values like `justify`, `justify-all` are not supported.
* The effect not apply to all elements, just `<text>` and `<input>`. In another way, it's not inherited.

## Example

```html
<template>
  <div>
    <text style="text-align: center;">Hello World</text>
  </div>
</template>
```
